-- Exemple de base de logiciel
-- PostGres
-- dropdb softwares ; psql -e -f soft_sample.sql template1

CREATE DATABASE softwares;
\connect softwares


BEGIN;
CREATE TABLE users (
	id	serial PRIMARY KEY,
	login   varchar(20) NOT NULL UNIQUE
);
CREATE INDEX users_login on users(login);


CREATE TABLE modification (
	id	serial PRIMARY KEY,
	date    timestamp,
	id_user    int references users(id)  
);

-- Une category de logiciel
CREATE TABLE category (
	id	serial PRIMARY KEY,
	name	text NOT NULL UNIQUE,
	id_modif	int references modification(id)
);

CREATE TABLE editor (
	id	serial PRIMARY KEY,
	name	text NOT NULL UNIQUE,
	address	text,
	url	text,
	id_modif	int references modification(id)
);
CREATE TABLE annotation (
	id	serial PRIMARY KEY,
	note	text NOT NULL UNIQUE,
	id_modif	int references modification(id)
);

CREATE TABLE softwares (
	id	serial PRIMARY KEY,
	name	text NOT NULL UNIQUE,
	category int references category(id),
	editor int references editor(id),
	note   int references annotation(id)
);



-- COPY category (id, name, id_modif) FROM stdin;
-- 1       Traitement de texte     \N
-- \.

-- COPY editor (id, name, address, url, id_modif) FROM stdin;
-- 1       GGo     montreuil       http://www.com  \N
-- \.

-- COPY softwares (id, name, category, editor) FROM stdin;
-- 1       mon tdtd        1       1
-- \.

COMMIT