//   DBComposer.java --- JDBForm

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.djedi.jdbforms.entries.Entry;
import org.djedi.jdbforms.forms.FormsPanel;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;


/**
 * Compose une ligne SQL
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: DBComposer.java,v 1.9 2004/06/12 11:17:10 djedi Exp $
 * @since Fri Jan 23 20:57:22 2004
 */
public class DBComposer {
  /**
   * Creates a new <code>DBComposer</code> instance.
   *
   */
  public DBComposer () {
  }

  private static Connection conn = null;
  /**
   * Donne une connection au systme. Ferme l'ancienne connection.
   * @param connection a <code>Connection</code> value
   */
  public static void setConnection(Connection connection) {
    try {
      if (conn!=null)
	conn.close();
      conn = connection;
    } catch (SQLException e) {
      e.printStackTrace();
    }
  }

  private static void doConnection() {
    new DBLogin(MainFrame.getFrame(),MainFrame.getFrame().getProperties(),false).show();
  }

  private static void execute (String q){
    try {
      Statement stm = conn.createStatement();
      stm.execute(q);
      stm.close();
    } catch (SQLException e) {
      e.printStackTrace();
      execute("ABORT;");
    }
  }



  public static ResultSet query (String q) throws SQLException {
    System.out.println(q);

    if (conn == null) doConnection();
    try {
      Statement stm = conn.createStatement();
      return stm.executeQuery(q);
      // } catch (SQLException e) {
      //   e.printStackTrace();
    } catch (NullPointerException e) {
      //      throw new SQLException(e.getMessage());
      //e.printStackTrace();
    }
    return null;
  }



  /**
   * Fabrique commande SQL pour inserer des donnes.
   * @param f a <code>FormsPanel</code> value
   */
  public static void insertSQL(FormsPanel f){
    String q ="BEGIN;\n";
    LinkedHashMap tables = new LinkedHashMap();

    for (Iterator i=f.getElements(); i.hasNext();) {
      Map.Entry en = (Map.Entry)i.next();
      Element elt = ((Element)en.getValue());
      NodeList nl = elt.getElementsByTagName("output");
      if ("no".equals(elt.getAttribute("optionnal")) &&
	  ((Entry)en.getKey()).isEmpty()) {
	MainFrame.getFrame().setStatus("<html><body>Form <font color=red>not valid</font>. Fix "+elt.getAttribute("title")+" field.</body></html>");
	return;
      }

      for (int j=0; j<nl.getLength(); j++) {
	// cherche la table, prend la premiere trouve puis prend le
	// premier noeud (suppose que PCDATA) puis renvoie sa valeur.
	// plante si pas de <table>
	String table = (((Element)nl.item(j)).getElementsByTagName("table")).item(0).getFirstChild().getNodeValue();
	String column = (((Element)nl.item(j)).getElementsByTagName("column")).item(0).getFirstChild().getNodeValue();
	List l = (List)tables.get(table);
	if (l==null)
	  l = new ArrayList();
	l.add(column);
	l.add(((Entry)en.getKey()).getSQLValue());
	tables.put(table,l);
      }
    }

    for (Iterator i = tables.entrySet().iterator(); i.hasNext();) {
      Map.Entry en = (Map.Entry)i.next();
      List l = (List)en.getValue();
      String cli="";
      String vli="";
      for (int j=0; j<l.size(); j+=2) {
	cli +=l.get(j);
	vli +=l.get(j+1);
	if (j<l.size()-2){
	  cli+=",";
	  vli+=",";
	}
      }
      q+="INSERT INTO "+en.getKey()+" ("+cli+") VALUES ("+vli+");\n";
    }

    //    q+="INSERT INTO "+table+"("+column+") VALUES ("+((Entry)en.getKey()).getSQLValue()+");\n";
    q +="COMMIT;";
    System.out.println(q);
    execute(q);
    MainFrame.getFrame().setStatus("<html><body>Form <font color=green>OK</font>.</body></html>");
  }


  public static ResultSet selectSQL(FormsPanel f) throws SQLException {
    // Cherche la (premire) requete.
    Element query_elt = (Element)f.getRootElement().getElementsByTagName("query").item(0);
    String query = query_elt.getAttribute("query");
    System.out.println(query);

    // Parse la requete et construit la vrai requete
    StringBuffer b = new StringBuffer();
    int i=-1,o=0;
    while (true) {
      i = query.indexOf('$',i+1);
      if (i==-1)
	break;
      b.append(query.substring(o,i));
      int j;
      for (j=i+1; query.charAt(j)>='a' &&  query.charAt(j)<='z' ;j++);
      if (f.getEntryByID(query.substring(i+1,j))==null){
	System.err.println("Parse Error in query composition: id "+query.substring(i+1,j)+" doesn't exist.");
	return null;
      }
      //      System.out.println("*"+b+" "+f.getEntryByID(query.substring(i+1,j)).getSQLValue());
      b.append(f.getEntryByID(query.substring(i+1,j)).getRawSQLValue());
      //      System.out.println("+"+b);
      o=j;
    }
    b.append(query.substring(o));

    System.out.println(b);
    return query(new String(b));    
  }
}
