//   DBLogin.java --- JDBForms

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.DriverManager;
import java.sql.SQLException;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;

import org.djedi.swing.LabelPassword;
import org.djedi.swing.LabelTextField;
import org.djedi.util.Properties;
import java.sql.Connection;


/**
 * Connecte  une SGBD.
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: DBLogin.java,v 1.4 2004/01/31 18:03:29 djedi Exp $
 * @since Sat Jan 24 18:08:51 2004
 */
public class DBLogin extends JDialog{
  private LabelTextField url;
  private LabelTextField login;
  private LabelPassword pw;

  /**
   * Creates a new <code>DBLogin</code> instance.
   *
   */
  public DBLogin(JFrame parent, Properties props) {
    this(parent,props,true);
  }
  public DBLogin(JFrame parent, Properties props, boolean urle) {
    super (parent,"Connect a DB",false);

    url = new LabelTextField("URL:",30,"jdbc:"+
					    props.getProperty("db.type")+"://"+
					    props.getProperty("db.host")+"/"+
					    props.getProperty("db.name"));

    url.setEnabled(urle);
    url.setVisible(!"false".equals(props.getProperty("login.url.show")));
    url.setEnabled(!"false".equals(props.getProperty("login.url.enabled")));
    login = new LabelTextField("Login:",15,props.getProperty("db.user"));
    pw = new LabelPassword ("Password:",15,props.getProperty("db.passwd"));
    JPanel p = new JPanel();
    p.setLayout(new BoxLayout(p,BoxLayout.Y_AXIS));
    getContentPane().add(p,BorderLayout.CENTER);
    p.add(url);

    p.add(login);
    p.add(pw);

    JButton connect = new JButton("Connect");
    connect.addActionListener(new DBConnectActionListener(this));
    getContentPane().add(connect,BorderLayout.SOUTH);
    pack();
  }


  private class DBConnectActionListener implements ActionListener {
    private DBLogin l;

    public DBConnectActionListener(DBLogin login) {
      l = login;
    }
    public void actionPerformed(ActionEvent e) {
      try {
	Connection c = DriverManager.getConnection(url.getText(),login.getText(),pw.getText());
	if (c!= null) {
	  DBComposer.setConnection(c);
	  l.dispose();
	}
      } catch (SQLException ex) {
	ex.printStackTrace();
      }
    }    
  }
}
