//   Porfolio.java --- JDBforms

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms;

import java.net.URL;
import javax.swing.JTabbedPane;

import org.djedi.jdbforms.forms.FormsPanelFactory;
import org.djedi.jdbforms.forms.FormsPanel;
import org.djedi.util.Properties;
import org.djedi.xml.XMLFacade;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;



/**
 * Gere un portefeuille de carte.
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: Porfolio.java,v 1.4 2004/06/13 09:23:34 djedi Exp $
 * @since Thu Jan 29 08:34:18 2004
 */
public class Porfolio {
  private Properties props;
  private Document doc;
  /**
   * Creates a new <code>Porfolio</code> instance.
   *
   */
  public Porfolio (URL load) {
    XMLFacade f = XMLFacade.createFacade();
    doc = f.readDocument(load);
    setProperties(doc);
 }

  protected void setProperties(Document d) {
    props = new Properties();
    NodeList nl = d.getElementsByTagName("property");
    for (int i=0; i<nl.getLength(); i++)    
      props.setProperty(((Element)nl.item(i)).getAttribute("name"),
			((Element)nl.item(i)).getAttribute("value"));
  }

  public Properties getProperties() {
    return props;
  }


  /**
   * Insere un porfolio dans l'interface
   * @param d a <code>Document</code> value
   */
  public void insertForm(MainFrame mf,JTabbedPane formsPanel) {
    Element elt = doc.getDocumentElement();
    if (!"porfolio".equals(elt.getTagName())){
      mf.setStatus("<html><body><font color=red>"+doc.getDocumentElement().getNodeName()+" is not a valid porfolio.</font></body></html>");
      return;
    }
    if ("porfolio".equals(elt.getTagName()) &&
	!"".equals(elt.getAttribute("title")))
      mf.setTitle(elt.getAttribute("title"));

    NodeList nl = doc.getElementsByTagName("form");
    for (int i=0; i<nl.getLength(); i++)
      if (!"none".equals(((Element)nl.item(i)).getAttribute("allow")))
	formsPanel.add(FormsPanelFactory.getPanel((Element)nl.item(i)));

    // Place les icones.
    for (int i=0; i<formsPanel.getTabCount(); i++) {
      formsPanel.setIconAt(i,((FormsPanel)formsPanel.getComponentAt(i)).getIcon());
    }
    

    mf.setStatus("Forms loaded");
  }
}
