//   LoadPortfolioAction.java --- JDBForms

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms.actions;

import org.djedi.jdbforms.*;
import org.djedi.xml.XMLFacade;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import java.io.File;
import java.awt.Component;
import org.w3c.dom.Document;
import java.net.MalformedURLException;

/**
 * Action qui charge un nouveau portfolio...
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: LoadPortfolioAction.java,v 1.5 2004/01/30 18:27:53 djedi Exp $
 * @since Wed Jan 21 17:09:26 2004
 */
public class LoadPortfolioAction extends AbstractAction {
  /**
   * Creates a new <code>LoadPortfolioAction</code> instance.
   *
   */
  public LoadPortfolioAction (MainFrame f) {
    super((Component)f, "Load",
	  "/toolbarButtonGraphics/general/Open24.gif",
	  "/toolbarButtonGraphics/general/Open16.gif",
	  "Load a new Porfolio", KeyEvent.VK_L);
    // putValue(SHORT_DESCRIPTION, "Create a new Instrument");
    // putValue(MNEMONIC_KEY, new Integer(KeyEvent.VK_N));
  }

  public void actionPerformed(ActionEvent e) {
    JFileChooser f = new JFileChooser();
    f.setFileFilter(new FileFilter(){
	public boolean accept(File fi) {
	  if (fi.isDirectory())
	    return true;
	  else if (fi.canRead() &&
		   fi.getName().endsWith("xml"))
	    return true;
	  return false;
	}
	public String getDescription(){
	  return "XML (*.xml)";
	}
      });
    if (f.showOpenDialog(frame) == JFileChooser.APPROVE_OPTION)
      try {
	System.out.println(f.getSelectedFile());
	MainFrame mf = (MainFrame)frame;
	mf.setPorfolio(new Porfolio(f.getSelectedFile().toURL()));
// 	mf.cleanForms();
// 	XMLFacade fac = XMLFacade.createFacade();
// 	Document doc = fac.readDocument(f.getSelectedFile().toURL());
// 	mf.insertForm(doc);
// 	mf.pack();
      } catch (MalformedURLException ex) {
	ex.printStackTrace();
      }
  }
}
