//   BooleanEntry.java --- Jdbforms

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms.entries;

import javax.swing.JLabel;
import java.awt.event.ActionListener;
import javax.swing.JCheckBox;

/**
 * Une entre Entire.
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: BooleanEntry.java,v 1.3 2004/06/12 11:16:31 djedi Exp $
 * @since Sat Jan 17 16:27:04 2004
 */
public class BooleanEntry extends Entry{
  private JCheckBox cb;

  /**
   * Creates a new <code>TextEntry</code> instance.
   *
   */
  public BooleanEntry (String text) {
    cb = new JCheckBox(text);
    add(cb);
  }

  /**
   * Get the Title value.
   * @return the Title value.
   */
  public String getTitle() {
    return cb.getText();
  }

  /**
   * Set the Title value.
   * @param newTitle The new Title value.
   */
  public void setTitle(String newTitle) {
    cb.setText(newTitle);
  }


  /**
   * Get the Integer value.
   * @return the Integer value.
   */
  public boolean getBoolean() {
    return cb.isSelected();
  }

  public void setDefault(String defaut) {
    setBoolean(Boolean.valueOf(defaut).booleanValue());
  }

  /**
   * Set the Integer value.
   * @param newInteger The new Integer value.
   */
  public void setBoolean(boolean newBoolean) {
    cb.setSelected(newBoolean);
  }

  public void addActionListener(ActionListener a) {
    cb.addActionListener(a);
  }

  public String getSQLValue() {
    return Boolean.toString(getBoolean());
  }
  public String getRawSQLValue() {
    return Boolean.toString(getBoolean());
  }

  public boolean isEmpty() {
      return false;
  }
  
}
