//   DateEntry.java --- Jdbforms

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms.entries;

import javax.swing.JLabel;
import kiwi.ui.DateChooserField;
import java.util.Date;
import java.awt.event.ActionListener;

/**
 * Une entre pour les dates.
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: DateEntry.java,v 1.9 2004/06/12 11:16:31 djedi Exp $
 * @since Sat Jan 17 16:27:04 2004
 */
public class DateEntry extends Entry{
  private JLabel label;
  private DateChooserField dc;

  public DateEntry (String text) {
    label = new JLabel(text);
    add(label);
    dc = new DateChooserField(15, "E d MMMMM yyyy");
    add(dc);
  }


  /**
   * Get the Date value.
   * @return the Date value.
   */
  public Date getDate() {
    return dc.getDate();
  }

  /**
   * Set the Date value.
   * @param newDate The new Date value.
   */
  public void setDate(Date newDate) {
    dc.setDate(newDate);
  }

  public void setDefault(String defaut) {
    setDate(new Date(defaut));
  }

  /**
   * Get the Title value.
   * @return the Title value.
   */
  public String getTitle() {
    return label.getText();
  }

  /**
   * Set the Title value.
   * @param newTitle The new Title value.
   */
  public void setTitle(String newTitle) {
    label.setText(newTitle);
  }

  public String getSQLValue() {
    return "'"+getRawSQLValue()+"'";
  }
  public String getRawSQLValue() {
    if (getDate()==null) {
      return "1/1/1900";
    }
    
    return new java.sql.Date(getDate().getTime()).toString();
  }

  public void addActionListener(ActionListener a) {
    //    tf.addActionListener(a);
  }
  
  public boolean isEmpty() {
    return getDate()==null;
  }
}
