//   Entry.java --- Jdbforms

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms.entries;

import javax.swing.JPanel;
import java.awt.Component;
import java.awt.event.ActionListener;



/**
 * Une entree dans le formulaire
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: Entry.java,v 1.7 2004/06/12 11:16:31 djedi Exp $
 * @since Sat Jan 17 16:26:00 2004
 */
public abstract class Entry extends JPanel {
  /**
   * Creates a new <code>Entry</code> instance.
   *
   */
  public Entry () {
  }

  /**
   * Active ou pas une entre. Applique le mme traitement aux enfants
   * de premiere gnration.
   *
   * @param flag a <code>boolean</code> value
   */
  public void setEnabled(boolean flag) {
    Component [] cli = getComponents();

    for (int i=0; i<cli.length; i++) {
      cli[i].setEnabled(flag);
    }
    super.setEnabled(flag);
  }

  /**
   * Renvoie la valeur de l'entre dans un format acceptable pour SQL.
   * @return a <code>String</code> value
   */
  public abstract String getSQLValue();
  /**
   * Renvoie la valeur brute de l'entre. L'enrobage de la valeur est effectu ailleurs.
   * @return a <code>String</code> value
   */
  public abstract String getRawSQLValue();
  public abstract void addActionListener(ActionListener a);
  
  /**
   * Renvoie true si l'entre est vide.
   * @return a <code>boolean</code> value
   */
  public abstract boolean isEmpty();

  /**
   * Fixe la valeur par defaut
   * @param defaut a <code>String</code> value
   */
  public abstract void setDefault(String defaut);
}
