//   EnumEntry.java --- Jdbforms

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms.entries;

import javax.swing.JLabel;
import java.util.Vector;
import javax.swing.JComboBox;
import java.awt.event.ActionListener;

/**
 * Une entre enumre.
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: EnumEntry.java,v 1.7 2004/06/12 11:16:31 djedi Exp $
 * @since Sat Jan 17 16:27:04 2004
 */
public class EnumEntry extends Entry{
  private JLabel title;
  private JComboBox combo;
  /**
   * Creates a new <code>TextEntry</code> instance.
   *
   */
  public EnumEntry (String text,Vector v) {
    title = new JLabel(text);
    combo = new JComboBox(v);

    add(title);
    add(combo);
  }

  /**
   * Get the Title value.
   * @return the Title value.
   */
  public String getTitle() {
    return title.getText();
  }

  /**
   * Set the Title value.
   * @param newTitle The new Title value.
   */
  public void setTitle(String newTitle) {
    title.setText(newTitle);
  }
  /**
   * Get the Value value.
   * @return the Value value.
   */
  public Object getValue() {
    return combo.getSelectedItem();
  }

  /**
   * Set the Value value.
   * @param newValue The new Value value.
   */
  public void setValue(int newValue) {
    combo.setSelectedIndex(newValue);
  }

  public void setDefault(String defaut) {
    setValue(Integer.parseInt(defaut));
  }

  public String getSQLValue() {
    return "'"+getValue().toString()+"'";
  }
  public String getRawSQLValue() {
    return getValue().toString();
  }

  public void addActionListener(ActionListener a) {
    combo.addActionListener(a);
  }
  
  public boolean isEmpty() {
    return getTitle()==null;
  }
  
}
