//   NullEntry.java --- Fungus -- A multi agent simulation framework

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms.entries;

import javax.swing.JLabel;
import java.awt.event.ActionListener;



/**
 * Une entre vide.
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: NullEntry.java,v 1.6 2004/06/12 11:16:31 djedi Exp $
 * @since Sat Jan 17 16:33:25 2004
 */
public class NullEntry extends Entry {
  /**
   * Creates a new <code>NullEntry</code> instance.
   *
   */
  public NullEntry () {
    add(new JLabel("Empty Entry"));
  }
  public void addActionListener(ActionListener a) {
  }

  public String getSQLValue() {
    return "";
  }
  public String getRawSQLValue() {
    return "";
  }

  public void setDefault(String defaut) {
  }  
  public boolean isEmpty() {
    return false;
  }
  
}
