//   SQLEntry.java --- Jdbforms

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms.entries;

import java.awt.event.ActionListener;
import java.sql.ResultSet;
import java.sql.SQLException;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;

import org.djedi.jdbforms.DBComposer;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Une entre ennumr pour les requete SQL.
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: SQLEntry.java,v 1.6 2004/06/12 11:16:31 djedi Exp $
 * @since Sat Jan 17 16:27:04 2004
 */
public class SQLEntry extends Entry implements PopupMenuListener{
  private JLabel label;
  private JComboBox list;
  private String query;
  private String columnin;
  private String columnout;
  private boolean stati = false;
  private boolean flag = false;

  public SQLEntry (String text,Element elt) {
    stati = "true".equals(elt.getAttribute("static"));
    query = elt.getAttribute("query");
    NodeList nl;

    Element cin = (Element)elt.getElementsByTagName("columnin").item(0);
    String colin = (cin.getElementsByTagName("column")).item(0).getFirstChild().getNodeValue();
    nl = cin.getElementsByTagName("table");
    if (nl.getLength()==0)
      columnin=colin;
    else{
      String tablein = nl.item(0).getFirstChild().getNodeValue();
      columnin=tablein+"."+colin;
    }
    Element cout = (Element)elt.getElementsByTagName("columnout").item(0);
    if (cout!=null){
      String colout = (cout.getElementsByTagName("column")).item(0).getFirstChild().getNodeValue();
      nl = cout.getElementsByTagName("table");
      if (nl.getLength()==0)
	columnout=colout;
      else {
	String tableout = nl.item(0).getFirstChild().getNodeValue();
	columnout=tableout+"."+colout;
      }
    }

    //    System.out.println(columnout);
    label = new JLabel(text);
    add(label);
    list = new JComboBox();
    list.addPopupMenuListener(this);
    add(list);
    list.setMaximumRowCount(25);
  }

  /**
   * Get the Title value.
   * @return the Title value.
   */
  public String getTitle() {
    return label.getText();
  }

  /**
   * Set the Title value.
   * @param newTitle The new Title value.
   */
  public void setTitle(String newTitle) {
    label.setText(newTitle);
  }

  public String getRawSQLValue() {
    return getSQLValue();
  }
  public String getSQLValue() {
    if (columnout==null)
      return "'"+list.getSelectedItem().toString()+"'";
    else
      return ((SEntry)list.getSelectedItem()).getValue().toString();
  }

  public void addActionListener(ActionListener a) {
    //    tf.addActionListener(a);
  }

  public boolean isEmpty() {
    return false;
  }

  public void setDefault(String defaut) {
  }

  public void popupMenuCanceled(PopupMenuEvent popupMenuEvent) {
  }

  public void popupMenuWillBecomeInvisible(PopupMenuEvent popupMenuEvent) {
  }

  /**
   * Describe <code>popupMenuWillBecomeVisible</code> method here.
   * @bug le popup reste ouvert
   * @param popupMenuEvent a <code>PopupMenuEvent</code> value
   */
  public void popupMenuWillBecomeVisible(PopupMenuEvent popupMenuEvent) {
    if (stati == true && flag==true)
      return;
    
    list.removeAllItems();
    try {
      ResultSet rs = DBComposer.query(query);

      for (rs.first(); !rs.isAfterLast(); rs.next()) {
	if (columnout==null)
	  list.addItem(rs.getObject(columnin));
	else
	  list.addItem(new SEntry(rs.getString(columnin),rs.getObject(columnout)));
      }
      rs.close();
      flag = true;
    } catch (SQLException e) {
      e.printStackTrace();
    } catch (NullPointerException e) {
      //      System.out.println(popupMenuEvent.getSource());
      //      ((JComboBox)popupMenuEvent.getSource()).setPopupVisible(false);
    }
  }

  private class SEntry {
    private String v;
    private Object s;
    public SEntry(String view, Object svalue){
      v= view;
      s= svalue;
      //      System.out.println(v+" "+s);
    }
    public String toString(){
      return v;
    }
    public Object getValue() {
      return s;
    }
  }
}
