//   TextAreaEntry.java --- Jdbforms

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms.entries;

import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;



/**
 * Une entre texte.
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: TextAreaEntry.java,v 1.4 2004/06/12 11:16:31 djedi Exp $
 * @since Sat Jan 17 16:27:04 2004
 */
public class TextAreaEntry extends Entry{
  private JLabel title;
  private JTextArea ta;
  /**
   * Creates a new <code>TextAreaEntry</code> instance.
   *
   */
  public TextAreaEntry (String text) {
    setLayout(new BorderLayout(5,5));
    title = new JLabel(text);
    title.setVerticalAlignment(SwingConstants.TOP);
    ta = new JTextArea(7,40);
    ta.setBorder(BorderFactory.createEtchedBorder());
    add(title,BorderLayout.WEST);
    add(ta,BorderLayout.CENTER);
  }

  /**
   * Get the Title value.
   * @return the Title value.
   */
  public String getTitle() {
    return title.getText();
  }

  /**
   * Set the Title value.
   * @param newTitle The new Title value.
   */
  public void setTitle(String newTitle) {
    title.setText(newTitle);
  }

  /**
   * Get the Text value.
   * @return the Text value.
   */
  public String getText() {
    return ta.getText();
  }

  /**
   * Set the Text value.
   * @param newText The new Text value.
   */
  public void setText(String newText) {
    ta.setText(newText);
  }

  public void setDefault(String defaut) {
    setText(defaut);
  }

  public String getSQLValue() {
    return "'"+getText()+"'";
  }
  public String getRawSQLValue() {
    return getText();
  }

  public void addActionListener(ActionListener a) {
  }
  
  public boolean isEmpty() {
    return "".equals(getText());
  }
  
}
