//   FormsPanelFactory.java --- JDBforms

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms.forms;

import org.w3c.dom.Element;



/**
 * Fabrique un Panel contenant un formulaire
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: FormsPanelFactory.java,v 1.4 2004/06/12 11:17:10 djedi Exp $
 * @since Wed Jun  2 11:01:33 2004
 */
public class FormsPanelFactory {
  static public FormsPanel getPanel(Element e){
   
    if ("insert".equals(e.getAttribute("type"))) {
      return new InsertFormsPanel(e);
    } else if ("select".equals(e.getAttribute("type"))) {
      return new SelectFormsPanel(e);      
    } else if ("info".equals(e.getAttribute("type"))) {
      return new InfoFormsPanel(e);      
    }
    
    return new EmptyFormsPanel(e);
  }
}
