//   SelectFormsPanel.java --- Fungus -- A multi agent simulation framework

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.jdbforms.forms;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.sql.ResultSet;
import java.sql.SQLException;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JTable;

import org.djedi.jdbforms.DBComposer;
import org.w3c.dom.Element;
import java.sql.ResultSetMetaData;
import javax.swing.table.DefaultTableModel;
import java.util.Vector;
import javax.swing.JScrollPane;
import javax.swing.ImageIcon;


/**
 *
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: SelectFormsPanel.java,v 1.6 2004/06/13 09:23:35 djedi Exp $
 * @since Wed Jun  2 11:35:25 2004
 */
public class SelectFormsPanel extends FormsPanel{
  private JTable table;

  /**
   * Creates a new <code>SelectFormsPanel</code> instance.
   *
   */
  public SelectFormsPanel (Element elt) {
    super(elt);

    setLayout(new BorderLayout());

    JPanel p = new JPanel();
    p.setLayout(new BoxLayout(p,BoxLayout.Y_AXIS));
    composeForm(elt,p);

    JSplitPane split = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
    split.setOneTouchExpandable(true);
    split.setTopComponent(p);
    table= new JTable();
    table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
    split.setBottomComponent(new JScrollPane(table));
    add(split,BorderLayout.CENTER);

    setIcon(new ImageIcon(elt.getClass().getResource("/toolbarButtonGraphics/general/Help16.gif")));
    validToolbar();
  }

  private void displayResult(ResultSet rs) {
    if (rs==null)
      return;
    
    try{
      ResultSetMetaData rsmd = rs.getMetaData();

      Vector dt = new Vector();
      for (rs.first(); rs.next();) {
	Vector v = new Vector();
	for (int i=1; i<=rsmd.getColumnCount(); i++)
	  v.add(rs.getObject(i));
	dt.add(v);
      }

      Vector cn = new Vector();
      for (int i=1; i<=rsmd.getColumnCount(); i++)
	cn.add(rsmd.getColumnLabel(i));
      
      DefaultTableModel tm = new DefaultTableModel(dt,cn);
      table.setModel(tm);

      exportable=tm;
      table.doLayout();
    } catch (SQLException e) {
      e.printStackTrace();
    }
  }


  protected void actionPerformed(ActionEvent actionEvent) {
    try{
      displayResult(DBComposer.selectSQL(this));
    } catch (SQLException e) {
      e.printStackTrace();
    }    
  }
}
