//   ActionMenuItem.java --- DJedi Lib

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.swing;

import javax.swing.Icon;
import javax.swing.JMenuItem;
import javax.swing.Action;

/**
 * Un menu qui gere les actions.
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: ActionMenuItem.java,v 1.1 2004/01/21 20:27:49 djedi Exp $
 * @since Wed Jan 21 20:12:10 2004
 */
public class ActionMenuItem extends JMenuItem {
  public ActionMenuItem(Action a) {
    super(a);
  }

  public void setAction(Action action) {
    super.setAction(action);
    if (action.getValue("MenuIcon")!=null)    
      setIcon((Icon)action.getValue("MenuIcon"));
  }
}
