/// LabelTextField.java --- DJedi Lib

/// Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

/// This program is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// This program is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with this program; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


package org.djedi.swing;

import javax.swing.JPanel;
import java.awt.Component;

/**
 * Un text field avec un label devant
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: LabelTextField.java,v 1.2 2004/01/29 08:26:32 djedi Exp $
 * @since Sat Jan 24 18:51:19 2004
 * @see JPanel
 */
public class LabelTextField extends JPanel {
    
    /** Creates new form LabelTextField */
    public LabelTextField() {
        initComponents();
    }

  /**
   * Creates a new <code>LabelTextField</code> instance.
   *
   * @param label a <code>String</code> value
   * @param column an <code>int</code> value
   */
  public LabelTextField(String label, int column) {
    this(label, column, null);
  }
  public LabelTextField(String label, int column, String defaut) {
        initComponents();
	setLabel(label);
	setColunm(column);
	setText(defaut);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();

        add(jLabel1);

        add(jTextField1);

    }//GEN-END:initComponents

    /** Getter for property label.
     * @return Value of property label.
     *
     */
    public String getLabel() {
        label = jLabel1.getText();
        return this.label;
    }    
    
    /** Setter for property label.
     * @param label New value of property label.
     *
     */
    public void setLabel(String label) {
        this.label = label;
        jLabel1.setText(label);
    }    
    
    /** Getter for property colunm.
     * @return Value of property colunm.
     *
     */
    public int getColunm() {
        colunm = jTextField1.getColumns();
        return this.colunm;
    }
    
    /** Setter for property colunm.
     * @param colunm New value of property colunm.
     *
     */
    public void setColunm(int colunm) {
        this.colunm = colunm;
        jTextField1.setColumns(colunm);
    }
    
    /** Getter for property text.
     * @return Value of property text.
     *
     */
    public String getText() {
        text = jTextField1.getText();
        return this.text;
    }
    
    /** Setter for property text.
     * @param text New value of property text.
     *
     */
    public void setText(String text) {
        this.text = text;
        jTextField1.setText(text);
    }


  /**
   * Active ou pas une entre. Applique le mme traitement aux enfants
   * de premiere gnration.
   *
   * @param flag a <code>boolean</code> value
   */
  public void setEnabled(boolean flag) {
    Component [] cli = getComponents();

    for (int i=0; i<cli.length; i++) {
      cli[i].setEnabled(flag);
    }
    super.setEnabled(flag);
  }

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables

    /** Holds value of property label. */
    private String label;    
    
    /** Holds value of property colunm. */
    private int colunm;
    
    /** Holds value of property text. */
    private String text;
    
}
