//   DebugUtilities.java --- DJedi Libs.

//   Copyright (C) 2004 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.util;

import java.util.logging.Logger;
import java.util.logging.Handler;
import java.util.logging.FileHandler;
import java.io.IOException;
import java.util.logging.Formatter;
import java.util.logging.SimpleFormatter;
import java.util.logging.Level;
import java.util.logging.Handler;
import java.util.logging.Handler;
import java.util.logging.LogRecord;
import java.util.Date;



/**
 * Classe utilitaires pour aider a dbugger les programmes.
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: DebugUtilities.java,v 1.2 2004/02/12 08:47:54 djedi Exp $
 * @since Sun Feb  8 12:29:26 2004
 */
public class DebugUtilities {
  /**
   * Creates a new <code>DebugUtilities</code> instance.
   *
   */
  public DebugUtilities () {
  }


  public static void main(String[] args) {
    try{
    Logger log = Logger.getLogger("org.djedi");
    log.setLevel(Level.ALL);
    Handler h = new FileHandler("%t/a.html");
    Formatter f = new XHTMLFormatter();
    h.setFormatter(f);
    log.addHandler(h);
    log.fine("toto");
    log.severe("toto");
    } catch (IOException e) {
      e.printStackTrace();
    }
  }


  public static  class XHTMLFormatter extends Formatter {

    /**
     * Describe <code>format</code> method here.
     *
     * @param log a <code>LogRecord</code> value
     * @return a <code>String</code> value
     */
    public String format(LogRecord log) {
      String s ="<p>";

      s += log.getMessage();
      s += " "+new Date(log.getMillis()).toString();

      s += "</p>";
      return s;
    }

    /**
     * Describe <code>getTail</code> method here.
     *
     * @param handler a <code>Handler</code> value
     * @return a <code>String</code> value
     */
    public String getTail(Handler handler) {
      return "<xhtml><body>";
    }
    
    /**
     * Describe <code>getHead</code> method here.
     *
     * @param handler a <code>Handler</code> value
     * @return a <code>String</code> value
     */
    public String getHead(Handler handler) {
      return "</body></xhtml>";
    }
    
  }
}
